Attribute VB_Name = "SKCModule"
Option Explicit

'Line Size: 80 Chars
'2345678901234567890123456789012345678901234567890123456789012345678901234567890

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
    (ByRef hpvDest As Any, ByRef hpvSource As Any, ByVal cbCopy As Long)
Private Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" _
    (ByRef hpvDest As Any, ByRef hpvSource As Any, ByVal cbCopy As Long)
Private Declare Sub FillMemory Lib "kernel32" Alias "RtlFillMemory" _
    (ByRef hpvDest As Any, ByVal cbCopy As Long, ByVal Char As Byte)

Private Type MIDI_CHN
    Used As Boolean
    Ctrl(&H0 To &H1F) As Byte
    RPNData(&H0 To &H1) As Byte
End Type

Public Type CONVERSION_OPTIONS
    LoopCtrl As Boolean
    LoopCnt As Byte
    FixLoops As Boolean
    StdzMidis As Boolean
End Type
Public Type STANDARDIZE_OPTIONS
    XGDrum As Boolean
    NoUncmnCtrls As Boolean
    Ctrls(&H0 To &H7F) As Boolean
    DrumBnkSel As Boolean
End Type

Public CnvOpts As CONVERSION_OPTIONS
Public StdzOpts As STANDARDIZE_OPTIONS

Public Function DecompressData(ByVal DataSize As Long, _
                                ByRef CmprData() As Byte, _
                                ByRef BinData() As Byte) As Long

    Dim RemBytes As Long    ' Remaining Bytes
    Dim DecmprBuf(&H0 To &HFFF) As Byte
    Dim DecmprOfs1 As Long
    Dim DecmprOfs2 As Long
    Dim dwCmd As Long
    Dim wWord As Long   ' actually unsigned 16-Bit
    Dim bCnt As Byte
    Dim BinSize As Long
    Dim SrcPos As Long
    Dim DstPos As Long
    
    Call CopyMemory(RemBytes, CmprData(&H0), &H4)
    Call CopyMemory(BinSize, CmprData(&H4), &H4)
    ReDim BinData(&H0 To BinSize - 1)
    
    Call FillMemory(DecmprBuf(&H0), &HFEE, &H0)
    DecmprOfs1 = &HFEE
    dwCmd = &H0
    
    SrcPos = &H8
    DstPos = &H0
    Do While SrcPos < DataSize
        'dwCmd = dwCmd >> 1
        dwCmd = Int(dwCmd / 2)
        
        If Not CBool(dwCmd And &H100) Then
            If RemBytes = 0 Then Exit Do
            
            dwCmd = &HFF00& Or CmprData(SrcPos)
            SrcPos = SrcPos + &H1
            RemBytes = RemBytes - &H1
        End If
        
        If CBool(dwCmd And &H1) Then
            If RemBytes = 0 Then Exit Do
            
            BinData(DstPos) = CmprData(SrcPos)
            DstPos = DstPos + &H1
            RemBytes = RemBytes - &H1
            
            DecmprBuf(DecmprOfs1) = CmprData(SrcPos)
            SrcPos = SrcPos + &H1
            DecmprOfs1 = DecmprOfs1 + &H1
            DecmprOfs1 = DecmprOfs1 And &HFFF
            
            GoTo Continue
        End If
        
        If RemBytes = 0 Then Exit Do
        
        wWord = CmprData(SrcPos) * &H100&
        SrcPos = SrcPos + &H1
        
        RemBytes = RemBytes - &H1
        If RemBytes = 0 Then Exit Do
        
        wWord = wWord Or CmprData(SrcPos)
        SrcPos = SrcPos + &H1
        
        RemBytes = RemBytes - &H1
        
        'DecmprOfs2 = (wWord >> 8) + ((wWord And &HF0) << 4)
        DecmprOfs2 = Int(wWord / &H100) + ((wWord And &HF0) * &H10)
        
        bCnt = (wWord And &HF) + 3
        Do Until bCnt = &H0
            BinData(DstPos) = DecmprBuf(DecmprOfs2)
            DecmprOfs2 = DecmprOfs2 + &H1
            DecmprOfs2 = DecmprOfs2 And &HFFF
            
            DecmprBuf(DecmprOfs1) = BinData(DstPos)
            DstPos = DstPos + &H1
            DecmprOfs1 = DecmprOfs1 + &H1
            DecmprOfs1 = DecmprOfs1 And &HFFF
            bCnt = bCnt - &H1
        Loop
Continue:
    Loop
    
    DecompressData = BinSize

End Function

Public Function CompressData(ByVal BinSize As Long, ByRef BinData() As Byte, _
                            ByRef CmprData() As Byte) As Long

    Dim ComprSize As Long
    Dim SrcPos As Long
    Dim DstPos As Long
    Dim CurByt As Byte
    
    ComprSize = &H8 + BinSize + Int(BinSize / &H8)
    ReDim CmprData(&H0 To ComprSize - 1)
    Call CopyMemory(CmprData(&H4), BinSize, &H4)
    
    SrcPos = &H0
    DstPos = &H8
    Do While SrcPos < BinSize
        CmprData(DstPos) = &HFF
        DstPos = DstPos + &H1
        For CurByt = &H0 To &H7
            CmprData(DstPos) = BinData(SrcPos)
            SrcPos = SrcPos + &H1
            DstPos = DstPos + &H1
        Next CurByt
    Loop
    
    ComprSize = DstPos - &H8
    Call CopyMemory(CmprData(&H0), ComprSize, &H4)
    CompressData = DstPos

End Function

Public Function BIN2MID(ByVal BinSize As Long, ByRef BinFile() As Byte, _
                        ByRef MidFile() As Byte) As Long

    Dim BinCommands As Long
    Dim BinPos As Long
    Dim MidPos As Long
    'Dim TempByt As Byte
    Dim TempInt As Integer
    Dim TempLng As Long
    Dim TempStr As String
    Dim TempArr() As Byte
    Dim LoopCnt As Integer
    Dim LoopPos As Long
    Dim LoopCmds As Long
    
    On Error GoTo ErrorInBIN
    
    Call CopyMemory(BinCommands, BinFile(&H4), &H4)
    If &H10 + BinCommands * 8 > BinSize Then GoTo ErrorInBIN
    
    Call CopyMemory(TempInt, BinFile(&H0), &H2)
    If TempInt <= 0 Then GoTo ErrorInBIN
    
    ' should be enough space
    ReDim MidFile(&H0 To BinSize * CnvOpts.LoopCnt + &HFF)
    
    ' Write MThd
    Call WriteBEValue(MidFile(), &H0, &H4D546864, &H4)
    Call WriteBEValue(MidFile(), &H4, &H6, &H4)
    Call WriteBEValue(MidFile(), &H8, &H0, &H2)
    Call WriteBEValue(MidFile(), &HA, &H1, &H2)
    Call WriteBEValue(MidFile(), &HC, TempInt, &H2)
    
    ' Write MTrk
    Call WriteBEValue(MidFile(), &HE, &H4D54726B, &H4)
    Call WriteBEValue(MidFile(), &H12, &H0, &H4)
    MidPos = &H16
    
    BinPos = &H10
    LoopCnt = &H0
    Do While BinPos < BinSize
        If BinCommands = &H0 Then Exit Do
        
        Call CopyMemory(TempLng, BinFile(BinPos), &H4)
        If TempLng < 0 Then GoTo ErrorInBIN
        MidPos = MidPos + WriteMIDIValue(MidFile(), MidPos, TempLng)
        BinPos = BinPos + &H4
        
        Select Case BinFile(BinPos + &H3)
        Case &H0    ' Normal Event
            Call CopyMemory(MidFile(MidPos), BinFile(BinPos), &H3)
            Select Case BinFile(BinPos + &H0) And &HF0
            Case &H80 To &HB0, &HE0
                MidPos = MidPos + &H3
            Case &HC0 To &HD0
                MidPos = MidPos + &H2
            End Select
        Case &H1    ' Tempo Event
            MidFile(MidPos + &H0) = &HFF
            MidFile(MidPos + &H1) = &H51
            MidFile(MidPos + &H2) = &H3
            MidFile(MidPos + &H3) = BinFile(BinPos + &H2)   ' convert
            MidFile(MidPos + &H4) = BinFile(BinPos + &H1)   ' LittleEndian to
            MidFile(MidPos + &H5) = BinFile(BinPos + &H0)   ' BigEndian
            MidPos = MidPos + &H6
        Case &H2
            ' Loop Start/End
            If LoopCnt < 2 Then
                If CnvOpts.LoopCtrl Then
                    ' write Controller 111
                    MidFile(MidPos + &H0) = &HB0
                    MidFile(MidPos + &H1) = &H6F
                    MidFile(MidPos + &H2) = LoopCnt
                    MidPos = MidPos + &H3
                Else
                    ' write Winamp-compatible Marker Event
                    TempStr = "loop" & IIf(LoopCnt And &H1, "End", "Start")
                    TempInt = Len(TempStr)
                    MidFile(MidPos + &H0) = &HFF
                    MidFile(MidPos + &H1) = &H6
                    MidFile(MidPos + &H2) = TempInt
                    TempArr() = StrConv(TempStr, vbFromUnicode)
                    Call CopyMemory(MidFile(MidPos + &H3), TempArr(&H0), _
                                    TempInt)
                    
                    MidPos = MidPos + &H3 + TempInt
                End If
            Else
                ' write empty Meta Event
                MidFile(MidPos + &H0) = &HFF
                MidFile(MidPos + &H1) = &H0
                MidFile(MidPos + &H2) = &H0
                MidPos = MidPos + &H3
            End If
            If LoopCnt = 0 Then
                LoopPos = BinPos
                LoopCmds = BinCommands
            ElseIf LoopCnt < CnvOpts.LoopCnt Then
                BinPos = LoopPos
                BinCommands = LoopCmds
            End If
            LoopCnt = LoopCnt + &H1
        End Select
        BinPos = BinPos + &H4
        BinCommands = BinCommands - &H1
    Loop
    
    ' Finalize track
    MidFile(MidPos + &H0) = &H0
    MidFile(MidPos + &H1) = &HFF
    MidFile(MidPos + &H2) = &H2F
    MidFile(MidPos + &H3) = &H0
    MidPos = MidPos + &H4
    
    TempLng = MidPos - &H16
    Call WriteBEValue(MidFile(), &H12, TempLng, &H4)
    
    ReDim Preserve MidFile(&H0 To MidPos - 1)
    BIN2MID = MidPos    ' return Size of MID file
    
    Exit Function

ErrorInBIN:

    MsgBox "Error in BIN-File!", vbCritical
    
    BIN2MID = &H0
    Exit Function

End Function

Public Function MID2BIN(ByVal MidSize As Long, ByRef MidFile() As Byte, _
                        ByRef BinFile() As Byte) As Long

    Dim BinSize As Long
    Dim MidPos As Long
    Dim BinPos As Long
    Dim MidData() As Byte
    Dim CmdCount As Long
    Dim PosTrkSt As Long
    Dim PosTrkLen As Long
    Dim EventArr() As Byte
    Dim EventLen As Long
    Dim EventData() As Byte
    Dim Delay As Long
    Dim MIDFmt As Integer
    Dim MidTrkCnt As Integer
    Dim CurTrk As Integer
    Dim TempInt As Integer
    Dim TempLng As Long
    Dim LoopCtrl As Boolean
    Dim LoopCmd As Long
    
    Call CopyMemory(TempLng, MidFile(&H0), &H4)
    If TempLng <> &H6468544D Then
        MsgBox "This is no MIDI-File!", vbCritical
        MID2BIN = &H0
        Exit Function
    End If
    
    EventLen = ReadBELong(MidFile(), &H4)
    MidPos = &H8
    MIDFmt = ReadBEShort(MidFile(), MidPos + &H0)
    MidTrkCnt = ReadBEShort(MidFile(), MidPos + &H2)
    TempInt = ReadBEShort(MidFile(), MidPos + &H4)  ' Resolution Rate
    MidPos = MidPos + EventLen
    
    If MidTrkCnt = 0 Then GoTo MIDIError
    If MIDFmt = 0 And MidTrkCnt > 1 Then
        ' there are programs, that generate bad headers
        ' e.g.: Format: 0, Tracks: 9
        ' it must be set to Format 1
        MIDFmt = 1
        MsgBox "I don't know which crappy MIDI program you use," & vbNewLine & _
                "but it generates bad MIDI Headers!", vbQuestion
    End If
    
    'On Error GoTo MIDIError
    
    BinSize = MidSize * 4
    ReDim BinFile(&H0 To BinSize - 1)
    BinPos = &H10
    
    TempLng = TempInt
    Call CopyMemory(BinFile(&H0), TempLng, &H4)
    
    If MIDFmt = 1 Then
        Call MIDI1to0(MidSize, MidFile(), TempLng, MidData())
        MidSize = TempLng
        MidTrkCnt = 1
    Else
        MidData() = MidFile()
    End If
    ReDim EventArr(&H0 To &H3)
    
    LoopCtrl = False
    LoopCmd = -1
    BinPos = &H10
    CmdCount = &H0
    For CurTrk = &H0 To MidTrkCnt - 1
        ' Check Track Header
        PosTrkSt = MidPos
        Call CopyMemory(TempLng, MidData(MidPos + &H0), &H4)
        If TempLng <> &H6B72544D Then
            ' No "MTrk"-Signature
            MsgBox "Track " & Format$(CurTrk) & " is invalid!", vbCritical
            MID2BIN = &H0
            Exit Function
        End If
        PosTrkLen = ReadBELong(MidData(), MidPos + &H4)
        MidPos = MidPos + &H8
        
        ' Convert the Track
        Do While MidPos < PosTrkSt + &H8 + PosTrkLen
            If ReadMIDEvt(MidData, MidPos, Delay, EventArr(), EventLen, _
                EventData) > &H0 Then _
                GoTo MIDIError
            
            Call CopyMemory(BinFile(BinPos), Delay, &H4)
            BinPos = BinPos + &H4
            
            Call ConvertEvent(BinFile, BinPos, LoopCtrl, EventArr, EventLen, _
                                EventData)
            If LoopCtrl And LoopCmd = -1 Then
                LoopCmd = CmdCount
            End If
            CmdCount = CmdCount + &H1
            If EventArr(&H0) = &HFF And EventArr(&H1) = &H2F Then _
                Exit Do
        Loop
        MidPos = MidPos + &H8
        MidPos = PosTrkSt + &H8 + PosTrkLen
    Next CurTrk
    
    If LoopCtrl Then
        ' only 1 Loop Marker found - attach 2nd one
        TempLng = &H0
        Call CopyMemory(BinFile(BinPos), TempLng, &H4)
        BinFile(BinPos + &H4) = &H0
        BinFile(BinPos + &H5) = &H0
        BinFile(BinPos + &H6) = &H0
        BinFile(BinPos + &H7) = &H2
        BinPos = BinPos + &H8
    End If
    
    If LoopCmd <> -1 Then
        TempLng = &H1
        Call CopyMemory(BinFile(&H8), TempLng, &H4)
        Call CopyMemory(BinFile(&HC), LoopCmd, &H4)
    End If
    
    BinSize = BinPos
    ReDim Preserve BinFile(&H0 To BinSize - 1)
    Call CopyMemory(BinFile(&H4), CmdCount, &H4)
    
    Call PostOptimizer(BinSize, BinFile(), &H0)
    
    MID2BIN = BinSize
    Exit Function

MIDIError:

    MsgBox "Error in MIDI-File!", vbCritical
    
    MID2BIN = &H0
    Exit Function

End Function

Private Sub PostOptimizer(ByRef BinSize As Long, ByRef BinFile() As Byte, _
                            ByVal AddFlags As Byte)

    Dim EvtCount As Long
    Dim SrcPos As Long
    Dim DstPos As Long
    Dim CurEvt As Long
    Dim Delay As Long
    Dim LastDly As Long
    Dim TempLng As Long
    Dim LoopNum As Byte
    
    Call CopyMemory(EvtCount, BinFile(&H4), &H4)
    
    ' --- Remove all NULL-Events ---
    SrcPos = &H10
    DstPos = SrcPos
    CurEvt = &H0
    LastDly = &H0
    Do While SrcPos < BinSize
        Call CopyMemory(Delay, BinFile(SrcPos + &H0), &H4)
        Call CopyMemory(TempLng, BinFile(SrcPos + &H4), &H4)
        SrcPos = SrcPos + &H8
        
        LastDly = LastDly + Delay
        If TempLng <> &H0 Then
            Call CopyMemory(BinFile(DstPos + &H0), LastDly, &H4)
            Call CopyMemory(BinFile(DstPos + &H4), TempLng, &H4)
            DstPos = DstPos + &H8
            CurEvt = CurEvt + &H1
            LastDly = &H0
        End If
    Loop
    EvtCount = CurEvt
    BinSize = DstPos
    
    Call CopyMemory(BinFile(&H4), EvtCount, &H4)
    ReDim Preserve BinFile(&H0 To BinSize - 1)
    
    If (AddFlags And &H80) Then Exit Sub
    
    ' Additional Modifications
    If CnvOpts.StdzMidis Then
        Call BIN_Standardize(BinSize, BinFile())
    End If
    
    Call CopyMemory(TempLng, BinFile(&H8), &H4)
    If TempLng <> &H0 Then
        If CnvOpts.FixLoops Then
            Call BIN_FixLoops(BinSize, BinFile())
        End If
        
        Call CopyMemory(EvtCount, BinFile(&H4), &H4)
        SrcPos = &H10
        CurEvt = &H0
        TempLng = &H0
        LoopNum = &H0
        Do While CurEvt < EvtCount
            If BinFile(SrcPos + &H7) = &H2 Then
                If LoopNum = &H0 Then
                    TempLng = CurEvt
                Else
                    EvtCount = CurEvt + &H1
                    BinSize = SrcPos + &H8
                    Call CopyMemory(BinFile(&H4), EvtCount, &H4)
                    ReDim Preserve BinFile(&H0 To BinSize - 1)
                    Exit Do
                End If
                LoopNum = LoopNum + &H1
            End If
            SrcPos = SrcPos + &H8
            CurEvt = CurEvt + &H1
        Loop
        Call CopyMemory(BinFile(&HC), TempLng, &H4)
    End If

End Sub

Private Sub BIN_Standardize(ByRef BinSize As Long, ByRef BinFile() As Byte)

    Dim EvtCount As Long
    Dim SrcPos As Long
    Dim DstPos As Long
    Dim CurEvt As Long
    Dim TempLng As Long
    Dim TempByt As Byte
    Dim CtrlLst(&H0 To &H1F) As Byte
    Dim CmnCtrl(&H0 To &H7F) As Byte
    Dim Chn(&H0 To &HF) As MIDI_CHN
    Dim CurChn As Byte
    Dim CurCtrl As Byte
    Dim EvtArr(&H0 To &H3) As Byte
    Dim InitArr() As Byte
    Dim IntroEvts As Long
    Dim RslRate As Long
    Dim DlyPos As Long
    
    Call CopyMemory(EvtCount, BinFile(&H4), &H4)
    
    For CurCtrl = &H0 To &H7F
        CmnCtrl(CurCtrl) = CByte(StdzOpts.Ctrls(CurCtrl)) And &H1
    Next CurCtrl
    CmnCtrl(&H6) = &H1  ' Data Entry MSB
    CmnCtrl(&H26) = &H1 ' Data Entry LSB
    CmnCtrl(&H60) = &H1 ' Data Increment
    CmnCtrl(&H61) = &H1 ' Data Decrement
    CmnCtrl(&H78) = &H2 ' All Sounds Off
    CmnCtrl(&H79) = &H2 ' Reset All Controllers
    CmnCtrl(&H7B) = &H3 ' All Notes Off
    
    For CurCtrl = &H0 To &H1F
        CtrlLst(CurCtrl) = &HFF
    Next CurCtrl
    CtrlLst(&H0) = &H0  ' Bank Sel MSB
    CtrlLst(&H1) = &H20 ' Bank Sel LSB
    CtrlLst(&H2) = &HC0 ' Instrument
    CtrlLst(&H3) = &H7  ' Volume
    CtrlLst(&H4) = &HA  ' Pan
    CtrlLst(&H5) = &H5B ' Reverb
    CtrlLst(&H6) = &H5C ' Tremolo
    CtrlLst(&H7) = &H5D ' Chorus
    CtrlLst(&H8) = &H5E ' Detune/Variation
    CtrlLst(&H9) = &H5F ' Phaser
    ' Sound Ctrls
    For CurCtrl = &H0 To &H9
        CtrlLst(&HA + CurCtrl) = &H46 + CurCtrl
    Next CurCtrl
    CtrlLst(&H1F) = &H80 ' Pitch Depth
    
    For CurCtrl = &H0 To &H1F
        If CtrlLst(CurCtrl) < &H80 Then
            If Not CBool(CmnCtrl(CtrlLst(CurCtrl)) And &H1) Then
                ' Don't write disabled controllers
                CtrlLst(CurCtrl) = &HFF
            End If
        End If
    Next CurCtrl
    
    ' Channel Setup
    For CurChn = &H0 To &HF
        With Chn(CurChn)
            For CurCtrl = &H0 To &H1E
                .Ctrl(CurCtrl) = &HFF
            Next CurCtrl
            .Ctrl(&H1F) = &H0
            .RPNData(&H0) = &H0
            .RPNData(&H1) = &H0
            
            If CurChn = &H9 And StdzOpts.DrumBnkSel Then
                For CurCtrl = &H0 To &H1F
                    If CtrlLst(CurCtrl) = &H0 Or CtrlLst(CurCtrl) = &H20 Then
                        ' disable Insertion of Bank MSB/LSB on Drum Channel
                        .Ctrl(CurCtrl) = &H0
                    End If
                Next CurCtrl
            End If
        End With
    Next CurChn
    
    ' 1. Analyse Channel Usage/Ctrls and delete uncommon Commands
    SrcPos = &H10
    CurEvt = &H0
    Do While CurEvt < EvtCount
        Call CopyMemory(EvtArr(&H0), BinFile(SrcPos + &H4), &H4)
        
        If EvtArr(&H3) = &H0 Then
            CurChn = EvtArr(&H0) And &HF
            With Chn(CurChn)
            
            Select Case EvtArr(&H0) And &HF0
            Case &H90
                'If EvtArr(&H2) = &H1 Then
                '    ' Remove Event
                '    TempLng = &H0
                '    Call CopyMemory(BinFile(SrcPos + &H4), TempLng, &H4)
                'End If
                .Used = True
            Case &HB0
                TempByt = &H0
                If EvtArr(&H1) >= &H62 And EvtArr(&H1) <= &H65 Then
                    ' Handle (N)RPNs
                    CurCtrl = (Not EvtArr(&H1)) And &H1
                    TempByt = (EvtArr(&H1) And &H2) * &H40
                    .RPNData(CurCtrl) = TempByt Or EvtArr(&H2)
                    TempByt = &H0
                    If StdzOpts.NoUncmnCtrls Then
                        If .RPNData(CurCtrl) < &H80 Then
                            If CmnCtrl(&H64) = &H0 Then _
                                TempByt = &H1
                        Else
                            If CmnCtrl(&H62) = &H0 Then _
                                TempByt = &H1
                        End If
                    End If
                ElseIf EvtArr(&H1) = &H6 Then
                    ' Handle Data MSB (for Pitch Bend Range)
                    If .RPNData(&H0) = &H0 And .RPNData(&H1) = &H0 Then
                        .Ctrl(&H1F) = EvtArr(&H1)
                    End If
                    If StdzOpts.NoUncmnCtrls Then
                        If .RPNData(CurCtrl) < &H80 Then
                            If CmnCtrl(&H64) = &H0 Then _
                                TempByt = &H1
                        Else
                            If CmnCtrl(&H62) = &H0 Then _
                                TempByt = &H1
                        End If
                    End If
                ElseIf EvtArr(&H1) = &H26 Or _
                    EvtArr(&H1) = &H60 Or EvtArr(&H1) = &H61 Then
                    ' Handle Data LSB / Data Inc/Dec
                    If StdzOpts.NoUncmnCtrls Then
                        If .RPNData(CurCtrl) < &H80 Then
                            If CmnCtrl(&H64) = &H0 Then _
                                TempByt = &H1
                        Else
                            If CmnCtrl(&H62) = &H0 Then _
                                TempByt = &H1
                        End If
                    End If
                Else
                    For CurCtrl = &H0 To &H1F
                        If CtrlLst(CurCtrl) = EvtArr(&H1) Then
                            .Ctrl(CurCtrl) = EvtArr(&H2)
                        End If
                    Next CurCtrl
                    
                    If StdzOpts.NoUncmnCtrls Then
                        If CmnCtrl(EvtArr(&H1)) = &H0 Then _
                            TempByt = &H1
                    End If
                    If CmnCtrl(EvtArr(&H1)) And &H2 Then _
                        TempByt = &H1
                    
                    If CurChn = &H9 And _
                        (EvtArr(&H1) = &H0 Or EvtArr(&H1) = &H20) Then
                        ' Handle Bank Select MSB/LSB on Drum Channel
                        If Not StdzOpts.DrumBnkSel Then
                            ' Correct Controllers
                            ' (depending on XG/GS and MSB/LSB)
                            If EvtArr(&H1) = &H0 And StdzOpts.XGDrum Then
                                BinFile(SrcPos + &H6) = &H7F
                            Else
                                BinFile(SrcPos + &H6) = &H0
                            End If
                        Else
                            ' Kill Controllers (-> always default setting)
                            TempByt = &H1
                        End If
                    End If
                End If
                
                If TempByt Then
                    ' Remove Event
                    TempLng = &H0
                    Call CopyMemory(BinFile(SrcPos + &H4), TempLng, &H4)
                End If
            Case &HC0
                .Ctrl(&H2) = EvtArr(&H1)
            Case &HE0
                If EvtArr(&H1) <> &H0 Or EvtArr(&H2) <> &H40 Then
                    If .Ctrl(&HF) = &H0 Then _
                        .Ctrl(&HF) = &HFF
                End If
            End Select
            
            End With
        End If
        SrcPos = SrcPos + &H8
        CurEvt = CurEvt + &H1
    Loop
    
    ' Option 80 makes sure that there're no endless recursive calls
    Call PostOptimizer(BinSize, BinFile(), &H80)
    Call CopyMemory(EvtCount, BinFile(&H4), &H4)
    
    ' 2. Insert Ctrl Instrument/BnkSel/Vol/Pan/Reverb/Chorus/PitchDepth
    '   Maybe insert too: FX Ctrls (5B-5F), Sound Ctrls (46-4F),
    '                      Mode Msgs (78-7F)
    ' ResetAllCtrl does: Mod/Expr/Pedals (40-43)/PitchBend
    ReDim InitArr(&H0 To (&H10 * &H22) * &H8 - 1)
    SrcPos = &H0
    CurEvt = &H0
    TempLng = &H0
    EvtArr(&H3) = &H0
    For CurChn = &H0 To &HF
        With Chn(CurChn)
        
        If .Used Then
        
        For CurCtrl = &H0 To &H1F
            If CtrlLst(CurCtrl) < &HFF And .Ctrl(CurCtrl) = &HFF Then
                Select Case CtrlLst(CurCtrl)
                Case &HC0
                    EvtArr(&H0) = &HC0 Or CurChn
                    EvtArr(&H1) = &H0 ' Grand Piano
                    EvtArr(&H2) = &H0
                Case &H0 To &H7F
                    TempByt = &H40
                    Select Case CtrlLst(CurCtrl)
                    Case &H0
                        If CurChn = &H9 And StdzOpts.XGDrum Then
                            TempByt = &H7F
                        Else
                            TempByt = &H0
                        End If
                    Case &H20, &H5C To &H5F
                        TempByt = &H0
                    Case &H7
                        TempByt = &H64
                    Case &HA, &H46 To &H4F
                        TempByt = &H40
                    Case &H5B
                        TempByt = &H28
                    Case Else
                        Debug.Print 1 / 0   ' make only the IDE stop
                    End Select
                    EvtArr(&H0) = &HB0 Or CurChn
                    EvtArr(&H1) = CtrlLst(CurCtrl)
                    EvtArr(&H2) = TempByt
                Case &H80
                    EvtArr(&H0) = &HB0 Or CurChn
                    EvtArr(&H1) = &H65
                    EvtArr(&H2) = &H0
                    Call CopyMemory(InitArr(SrcPos + &H0), TempLng, &H4)
                    Call CopyMemory(InitArr(SrcPos + &H4), EvtArr(&H0), &H4)
                    SrcPos = SrcPos + &H8
                    CurEvt = CurEvt + &H1
                    
                    EvtArr(&H0) = &HB0 Or CurChn
                    EvtArr(&H1) = &H64
                    EvtArr(&H2) = &H0
                    Call CopyMemory(InitArr(SrcPos + &H0), TempLng, &H4)
                    Call CopyMemory(InitArr(SrcPos + &H4), EvtArr(&H0), &H4)
                    SrcPos = SrcPos + &H8
                    CurEvt = CurEvt + &H1
                    
                    EvtArr(&H0) = &HB0 Or CurChn
                    EvtArr(&H1) = &H6
                    EvtArr(&H2) = &H2
                End Select
                Call CopyMemory(InitArr(SrcPos + &H0), TempLng, &H4)
                Call CopyMemory(InitArr(SrcPos + &H4), EvtArr(&H0), &H4)
                SrcPos = SrcPos + &H8
                CurEvt = CurEvt + &H1
            End If
        Next CurCtrl
        
        End If
        
        End With
    Next CurChn
    
    ' Skip Tempo Command
    DstPos = &H10
    Do While DstPos < BinSize
        If BinFile(DstPos + &H7) <> &H1 Then Exit Do
        DstPos = DstPos + &H8
    Loop
    
    TempLng = BinSize + SrcPos
    ReDim Preserve BinFile(&H0 To TempLng - 1)
    Call MoveMemory(BinFile(SrcPos + DstPos), BinFile(DstPos), BinSize - DstPos)
    Call CopyMemory(BinFile(DstPos), InitArr(&H0), SrcPos)
    BinSize = TempLng
    
    Call CopyMemory(TempLng, BinFile(&H4), &H4)
    EvtCount = TempLng + CurEvt
    Call CopyMemory(BinFile(&H4), EvtCount, &H4)
    
    'If True Then Exit Sub
    
    ' 3. Force 1/8 Delay between song start and 1st command
    ' 3.1. Count Events before Delay
    SrcPos = &H10
    CurEvt = &H0
    IntroEvts = &H0
    Do While CurEvt < EvtCount
        Call CopyMemory(EvtArr(&H0), BinFile(SrcPos + &H4), &H4)
        
        If EvtArr(&H3) <> &H1 Then
            If EvtArr(&H3) = &H2 Then EvtArr(&H0) = &H90
            IntroEvts = IntroEvts + &H1
            
            CurChn = EvtArr(&H0) And &HF
            Select Case EvtArr(&H0) And &HF0
            Case &H90
                ' Insert a 1/8 Delay
                IntroEvts = IntroEvts - &H1
                SrcPos = SrcPos + &H8
                Exit Do
            End Select
        End If
        SrcPos = SrcPos + &H8
        CurEvt = CurEvt + &H1
    Loop
    DstPos = SrcPos
    
    ' 3.2. Write Delay Times
    Call CopyMemory(RslRate, BinFile(&H0), &H4)
    'RslRate = RslRate / 2
    CurEvt = &H0
    SrcPos = &H10
    DlyPos = &H0
    Do While SrcPos < DstPos
        Call CopyMemory(EvtArr(&H0), BinFile(SrcPos + &H4), &H4)
        
        If EvtArr(&H3) = &H2 Then
            EvtArr(&H0) = &H90
        ElseIf EvtArr(&H3) = &H1 Then
            EvtArr(&H0) = &H0
        End If
        
        If EvtArr(&H3) = &H1 And CurEvt = &H0 Then
            TempLng = DlyPos
            CurEvt = CurEvt + &H1
        Else
            CurEvt = CurEvt + &H1
            If CurEvt <= IntroEvts Then
                TempLng = Int(RslRate * CurEvt * 180 / (IntroEvts * 480))
            Else
                TempLng = RslRate / 2
            End If
            If CurEvt = &H1 And TempLng = 0 Then
                ' force 1 tick space between inital Tempo and 1st event
                TempLng = 1
            ElseIf TempLng < DlyPos Then
                ' prevent negative delays (because of the line above)
                TempLng = DlyPos
            End If
        End If
        'If TempLng > DlyPos Then
            DlyPos = TempLng - DlyPos
            Call CopyMemory(BinFile(SrcPos + &H0), DlyPos, &H4)
            DlyPos = TempLng
        'End If
        
        Select Case EvtArr(&H0) And &HF0
        Case &H90
            Exit Do
        End Select
        If EvtArr(&H3) = &H1 Then
            CurEvt = CurEvt - &H1
        End If
        SrcPos = SrcPos + &H8
    Loop
 
End Sub

Private Sub BIN_FixLoops(ByRef BinSize As Long, ByRef BinFile() As Byte)

    Dim EvtCount As Long
    Dim SrcPos As Long
    Dim DstPos As Long
    Dim CurEvt As Long
    Dim TempLng As Long
    'Dim TempByt As Byte
    Dim TempArr() As Byte
    Dim LoopNum As Byte
    Dim SvNtCount As Long
    Dim SvNts(&H0 To &HFF) As Long
    Dim SNCntB As Long
    Dim SNsB() As Long  ' Save Notes Backup
    
    Call CopyMemory(EvtCount, BinFile(&H4), &H4)
    
    ' Step 1: Move Notes and Controllers at the Loop Ticks
    DstPos = &H10
    CurEvt = &H0
    LoopNum = &H0
    Do While CurEvt < EvtCount
        If BinFile(DstPos + &H7) = &H2 Then
            ' Seek to Loop Start and End
            SrcPos = DstPos
            Do While SrcPos > &H0
                Call CopyMemory(TempLng, BinFile(SrcPos), &H4)
                If TempLng <> &H0 Then Exit Do
                SrcPos = SrcPos - &H8
            Loop
            
            DstPos = DstPos + &H8
            CurEvt = CurEvt + &H1
            Do While DstPos < BinSize
                Call CopyMemory(TempLng, BinFile(DstPos), &H4)
                If TempLng <> &H0 Then Exit Do
                DstPos = DstPos + &H8
                CurEvt = CurEvt + &H1
            Loop
            
            ' SrcPos - Loop Tick Start
            ' DstPos - Loop Tick End
            TempLng = DstPos - SrcPos
            If TempLng = &H0 Then Stop
            If TempLng > &H0 Then
                ReDim TempArr(&H0 To TempLng - 1)
                Call CopyMemory(TempArr(&H0), BinFile(SrcPos), TempLng)
                Call SortEvents(TempLng, TempArr(), LoopNum)
                Call CopyMemory(BinFile(SrcPos), TempArr(&H0), TempLng)
            End If
            
            LoopNum = LoopNum + &H1
            DstPos = DstPos - &H8
            CurEvt = CurEvt - &H1
        End If
        DstPos = DstPos + &H8
        CurEvt = CurEvt + &H1
        
        If LoopNum >= &H2 Then Exit Do
    Loop
    EvtCount = CurEvt
    BinSize = DstPos
    Call CopyMemory(BinFile(&H4), EvtCount, &H4)
    
    ' Step 2: Check for hanging notes
    SrcPos = &H10
    CurEvt = &H0
    LoopNum = &H0
    Do While CurEvt < EvtCount
        Select Case BinFile(SrcPos + &H7)
        Case &H0    ' Standard Command
        
        Select Case BinFile(SrcPos + &H4) And &HF0
        Case &H80, &H90
            Call CopyMemory(TempLng, BinFile(SrcPos + &H4), &H4)
            If (BinFile(SrcPos + &H4) And &HF0) = &H80 Or _
                BinFile(SrcPos + &H6) = &H0 Then
                ' Note off
                
                ' Set NoteOn-Bit and mask out Velocity
                TempLng = (TempLng And &HFFFF&) Or &H10&
                For DstPos = &H0 To SvNtCount - 1
                    If SvNts(DstPos) = TempLng Then
                    
                    ' Remove Note from List
                    TempLng = (SvNtCount - &H1 - DstPos) * &H4
                    Call MoveMemory(SvNts(DstPos), SvNts(DstPos + &H1), TempLng)
                    SvNtCount = SvNtCount - &H1
                    Exit For
                    
                    End If
                Next DstPos
            Else
                ' Note on
                If SvNtCount >= &H100 Then
                    ' that's very unusual, but I already saw that
                    ' (OK, the MIDI was quite broken, but people do everything)
                    Call MoveMemory(SvNts(&H0), SvNts(&HC0), &H40 * &H4)
                    SvNtCount = SvNtCount - &HC0
                End If
                ' Add note (without Velocity)
                SvNts(SvNtCount) = TempLng And &HFFFF&
                SvNtCount = SvNtCount + &H1
            End If
        End Select
        
        Case &H2    ' Loop Marker
        
        If LoopNum = &H0 Then
            ' Save Note State
            SNCntB = SvNtCount
            If SNCntB > &H0 Then
                ReDim SNsB(&H0 To SNCntB - 1)
                Call CopyMemory(SNsB(&H0), SvNts(&H0), SNCntB * &H4)
            End If
        Else
            ' Check Note State
            Call CompareNoteLists(SNCntB, SNsB(), SvNtCount, SvNts())
            If SvNtCount > &H0 Then
                TempLng = SvNtCount * &H8
                ReDim Preserve BinFile(&H0 To BinSize + TempLng - 1)
                Call MoveMemory(BinFile(SrcPos + &H4 + TempLng), _
                                BinFile(SrcPos + &H4), _
                                BinSize - &H4 - SrcPos)
                BinSize = BinSize + TempLng
                TempLng = &H0
                For DstPos = &H0 To SvNtCount - 1
                    ' Copy Note and next delay
                    Call CopyMemory(BinFile(SrcPos + &H4), SvNts(DstPos), &H4)
                    Call CopyMemory(BinFile(SrcPos + &H8), TempLng, &H4)
                    
                    SrcPos = SrcPos + &H8
                    CurEvt = CurEvt + &H1
                Next DstPos
                EvtCount = EvtCount + SvNtCount
            End If
        End If
        LoopNum = LoopNum + &H1
        
        End Select
        SrcPos = SrcPos + &H8
        CurEvt = CurEvt + &H1
        
        If LoopNum >= &H2 Then Exit Do
    Loop
    EvtCount = CurEvt
    Call CopyMemory(BinFile(&H4), EvtCount, &H4)

End Sub

Private Sub SortEvents(ByVal DataSize As Long, ByRef Data() As Byte, _
                        ByVal Mode As Byte)

    Dim LoopPos As Long
    Dim LoopAPos As Long
    Dim LoopPPos As Long
    Dim SrcPos As Long
    Dim DstPos As Long
    Dim TempLng As Long
    Dim Cmd As Byte
    
    LoopPos = &H0
    Do Until Data(LoopPos + &H7) = &H2
        LoopPos = LoopPos + &H8
    Loop
    LoopAPos = LoopPos
    LoopPPos = LoopPos
    
    SrcPos = &H0
    Do While SrcPos < DataSize
        If Data(SrcPos + &H7) <> &H2 Then
        
        If Data(SrcPos + &H7) = &H0 Then
            Cmd = Data(SrcPos + &H4) And &HF0
        Else
            Cmd = &HFF
        End If
        If Cmd = &H80 Or (Cmd = &H90 And Data(SrcPos + &H6) = &H0) Then
            If SrcPos < LoopPos Then
                ' Good - it should be like that
            Else
                ' that might cause endless ntoes
                ' move them in front of the Loop Marker
                Call CopyMemory(TempLng, Data(SrcPos + &H4), &H4)
                Call MoveMemory(Data(LoopPPos + &HC), Data(LoopPPos + &H4), _
                                SrcPos - LoopPPos - &H4)
                Call CopyMemory(Data(LoopPPos + &H4), TempLng, &H4)
                LoopPos = LoopPos + &H8
                LoopPPos = LoopPPos + &H8
                LoopAPos = LoopAPos + &H8
            End If
        Else
            If SrcPos >= LoopPos Then
                ' that's OK
            Else
                ' these Notes should be played AFTER the Loop Marker
                ' move them behind it
                If Cmd <= &H90 Or Mode = &H0 Then
                    Call CopyMemory(TempLng, Data(SrcPos + &H4), &H4)
                    Call MoveMemory(Data(SrcPos + &H4), Data(SrcPos + &HC), _
                                    LoopAPos - SrcPos - &H4)
                    Call CopyMemory(Data(LoopAPos + &H4), TempLng, &H4)
                    LoopPos = LoopPos - &H8
                    LoopPPos = LoopPPos - &H8
                    'LoopAPos = LoopAPos - &H8
                    'LoopAPos = LoopAPos + &H8   ' Keep order of events
                    SrcPos = SrcPos - &H8
                End If
            End If
        End If
        
        End If
        SrcPos = SrcPos + &H8
    Loop

End Sub

Private Sub CompareNoteLists(ByVal L1Count As Long, ByRef L1Val() As Long, _
                            ByRef L2Count As Long, ByRef L2Val() As Long)

    ' Compare Lists and remove all notes found in List 1 and 2 from List 2
    Dim CurL1 As Long
    Dim CurL2 As Long
    Dim MoveCnt As Long
    
    CurL2 = &H0
    ' I need a Do-While for List 2 as L2Count may change during the loop
    Do While CurL2 < L2Count
        For CurL1 = &H0 To L1Count - 1
            If L2Val(CurL2) = L1Val(CurL1) Then
            
            MoveCnt = L2Count - &H1 - CurL2
            If MoveCnt > &H0 Then
                Call MoveMemory(L2Val(CurL2), L2Val(CurL2 + &H1), MoveCnt * &H4)
            End If
            CurL2 = CurL2 - &H1
            L2Count = L2Count - &H1
            Exit For
            
            End If
        Next CurL1
        CurL2 = CurL2 + &H1
    Loop

End Sub


Private Function ReadBELong(ByRef FileData() As Byte, ByVal Pos As Long) As Long

    Dim TempArr(&H0 To &H3) As Byte
    Dim TempLng As Long
    Dim CurByt As Byte
    
    For CurByt = &H0 To &H3
        TempArr(&H3 - CurByt) = FileData(Pos + CurByt)
    Next CurByt
    
    Call CopyMemory(TempLng, TempArr(&H0), &H4)
    ReadBELong = TempLng

End Function

Private Function ReadBEShort(ByRef FileData() As Byte, ByVal Pos As Long) _
                            As Integer

    Dim TempArr(&H0 To &H1) As Byte
    Dim TempSht As Integer
    Dim CurByt As Byte
    
    For CurByt = &H0 To &H1
        TempArr(&H1 - CurByt) = FileData(Pos + CurByt)
    Next CurByt
    
    Call CopyMemory(TempSht, TempArr(&H0), &H2)
    ReadBEShort = TempSht

End Function

Private Sub WriteBEValue(ByRef FileData() As Byte, ByVal Pos As Long, _
                        ByVal Value As Long, ByVal ValSize As Byte)

    Dim TempArr(&H0 To &H3) As Byte
    Dim CurByt As Byte
    
    Call CopyMemory(TempArr(&H0), Value, ValSize)
    
    For CurByt = &H0 To ValSize - 1
        FileData(Pos + CurByt) = TempArr(ValSize - 1 - CurByt)
    Next CurByt

End Sub

Private Function ReadMIDIValue(ByRef FileData() As Byte, ByVal Pos As Long, _
                                ByRef Value As Long) As Long

    Dim CurPos As Long
    Dim TempLng As Long
    
    CurPos = Pos
    TempLng = &H0
    Do While FileData(CurPos) And &H80
        TempLng = (TempLng * &H80) Or FileData(CurPos) And &H7F
        CurPos = CurPos + &H1
    Loop
    TempLng = (TempLng * &H80) Or FileData(CurPos) And &H7F
    CurPos = CurPos + &H1
    
    Value = TempLng
    ReadMIDIValue = CurPos - Pos

End Function

Private Function WriteMIDIValue(ByRef FileData() As Byte, ByVal Pos As Long, _
                                ByVal Value As Long) As Long

    Dim CurPos As Long
    Dim ByteCount As Byte
    Dim TempLng As Long
    
    TempLng = Value
    ByteCount = &H0
    Do
        TempLng = Int(TempLng / &H80)
        ByteCount = ByteCount + &H1
    Loop While TempLng
    
    TempLng = Value
    CurPos = Pos + (ByteCount - &H1)
    FileData(CurPos) = &H0 Or (TempLng And &H7F)
    TempLng = Int(TempLng / &H80)
    
    Do While TempLng
        CurPos = CurPos - &H1
        FileData(CurPos) = &H80 Or (TempLng And &H7F)
        TempLng = Int(TempLng / &H80)
    Loop
    
    WriteMIDIValue = ByteCount

End Function

Private Function ReadMIDEvt(ByRef MIDIFile() As Byte, ByRef MidPos As Long, _
                            ByRef RetDelay As Long, ByRef EventArr() As Byte, _
                            ByRef EventLen As Long, ByRef EventData() As Byte) _
                            As Byte

    Dim PosE As Long
    Dim EvDtLen As Long
    
    PosE = MidPos
    EvDtLen = &H0
    Do
        EvDtLen = (EvDtLen * &H80) Or (MIDIFile(PosE) And &H7F)
        PosE = PosE + &H1
    Loop While CBool(MIDIFile(PosE - &H1) And &H80)
    RetDelay = EvDtLen
    
    If MIDIFile(PosE + &H0) And &H80 Then
        EventArr(&H0) = MIDIFile(PosE + &H0)
        If EventArr(&H0) < &HF0 Then _
            EventArr(&H3) = EventArr(&H0)
        PosE = PosE + &H1
    Else
        EventArr(&H0) = EventArr(&H3)
    End If
    
    EventArr(&H1) = MIDIFile(PosE + &H0)
    EventArr(&H2) = MIDIFile(PosE + &H1)
    EvDtLen = &H0
    Select Case EventArr(&H0) And &HF0
    Case &H80, &H90, &HA0, &HB0, &HE0
        ' Note off, Note on/off, Note Aftertouch, Control Change, Pitch Bend
        PosE = PosE + &H2
    Case &HC0, &HD0
        ' Patch Change, Channel Aftertouch
        PosE = PosE + &H1
        EventArr(&H2) = &H0
    Case &HF0   ' Other
        EventArr(&H2) = &H0
        
        Select Case EventArr(&H0)
        Case &HF0   ' System Exclusive-Data
            EvDtLen = &H0
            Do
                EvDtLen = (EvDtLen * &H80) Or (MIDIFile(PosE) And &H7F)
                PosE = PosE + &H1
            Loop While CBool(MIDIFile(PosE - &H1) And &H80)
            
            'ReDim EventData(&H0 To EvDtLen - 1)
            'Call CopyMemory(EventData(&H0), MIDIFile(PosE), EvDtLen)
            EventArr(&H1) = MIDIFile(PosE)
            PosE = PosE + EvDtLen
        Case &HFF   ' Meta Event
            PosE = PosE + &H1
            EvDtLen = &H0
            Do
                EvDtLen = (EvDtLen * &H80) Or (MIDIFile(PosE) And &H7F)
                PosE = PosE + &H1
            Loop While CBool(MIDIFile(PosE - &H1) And &H80)
            
            If EvDtLen > &H0 Then
                ReDim EventData(&H0 To EvDtLen - 1)
                Call CopyMemory(EventData(&H0), MIDIFile(PosE), EvDtLen)
            End If
            PosE = PosE + EvDtLen
        Case Else   ' Undefined
            ReadMIDEvt = &HFF
            Exit Function
        End Select
    End Select
    MidPos = PosE
    EventLen = EvDtLen
    
    ReadMIDEvt = &H0

End Function

Private Sub ConvertEvent(ByRef BinFile() As Byte, ByRef CurPos As Long, _
                        ByRef LoopCtrl As Boolean, ByRef EventArr() As Byte, _
                        ByVal EventLen As Long, ByRef EventData() As Byte)

    'Dim TempByt As Byte
    'Dim TempSht As Integer
    'Dim TempLng As Long
    Dim TempStr As String
    Dim BinPos As Long
    Dim LoopText As Byte
    
    BinPos = CurPos
    If EventArr(&H0) < &HF0 Then
        BinFile(BinPos + &H0) = EventArr(&H0)
        BinFile(BinPos + &H1) = EventArr(&H1)
        BinFile(BinPos + &H2) = EventArr(&H2)
        BinFile(BinPos + &H3) = &H0
        
        If (EventArr(&H0) And &HF0) = &HB0 And EventArr(&H1) = 111 Then
            BinFile(BinPos + &H0) = &H0
            BinFile(BinPos + &H1) = &H0
            BinFile(BinPos + &H2) = &H0
            BinFile(BinPos + &H3) = &H2
            LoopCtrl = Not LoopCtrl
        End If
        BinPos = BinPos + &H4
    Else
        Select Case EventArr(&H0)
        Case &HF0
            ' write NULL-Event (it's stripped later)
            BinFile(BinPos + &H0) = &H0
            BinFile(BinPos + &H1) = &H0
            BinFile(BinPos + &H2) = &H0
            BinFile(BinPos + &H3) = &H0
            BinPos = BinPos + &H4
        Case &HFF
            If EventArr(&H1) = &H51 Then
                BinFile(BinPos + &H0) = EventData(&H2)
                BinFile(BinPos + &H1) = EventData(&H1)
                BinFile(BinPos + &H2) = EventData(&H0)
                BinFile(BinPos + &H3) = &H1
                BinPos = BinPos + &H4
            Else
                LoopText = &H0
                If EventArr(&H1) = &H6 Then
                    ' Copy String and remove Spaces
                    TempStr = StrConv(EventData(), vbUnicode)
                    TempStr = UCase$(Replace$(TempStr, " ", ""))
                    
                    If Left$(TempStr, 9) = "LOOPSTART" Then
                        LoopText = &H1
                    ElseIf Left$(TempStr, 7) = "LOOPEND" Then
                        LoopText = &H2
                    ElseIf Left$(TempStr, 5) = "START" Then
                        LoopText = &H1
                    ElseIf Left$(TempStr, 3) = "END" Then
                        LoopText = &H2
                    ElseIf Left$(TempStr, 8) = "LOOPFROM" Then
                        LoopText = &H1
                    ElseIf Left$(TempStr, 6) = "LOOPTO" Then
                        LoopText = &H2
                    End If
                End If
                
                Select Case LoopText
                Case &H1
                    BinFile(BinPos + &H0) = &H0
                    BinFile(BinPos + &H1) = &H0
                    BinFile(BinPos + &H2) = &H0
                    BinFile(BinPos + &H3) = &H2
                    BinPos = BinPos + &H4
                    LoopCtrl = True
                Case &H2
                    BinFile(BinPos + &H0) = &H0
                    BinFile(BinPos + &H1) = &H0
                    BinFile(BinPos + &H2) = &H0
                    BinFile(BinPos + &H3) = &H2
                    BinPos = BinPos + &H4
                    LoopCtrl = False
                Case &H0
                    ' write NULL-Event
                    BinFile(BinPos + &H0) = &H0
                    BinFile(BinPos + &H1) = &H0
                    BinFile(BinPos + &H2) = &H0
                    BinFile(BinPos + &H3) = &H0
                    BinPos = BinPos + &H4
                End Select
            End If
        End Select
    End If
    CurPos = BinPos

End Sub
